/**
   AggregatedElement extends ElementImpl

   created by Ryuichiro Higashinaka 
   2005/05/26
   2005/05/28 receives RSTElement in constructor
   2005/06/01 change name to aggregatedElement

**/

package jsparky;

import org.apache.xerces.dom.*;
import java.util.*;
import org.w3c.dom.*;

public class AggregatedElement extends BaseElement implements Aggregatable {

    //Document dss;
    AggregationResult result;
    Operation operation;
    String ns = Relation.NUCLEUS;
    RSTElement rst_elem;

    public AggregatedElement(Document doc, AggregationResult result, RSTElement rst_elem, Operation operation){
	super((CoreDocumentImpl)doc, BaseElement.AGGREGATEDELEMENT_TAGNAME);
	this.operation = operation;
	this.result = result;
	this.rst_elem = rst_elem;
	if(result.getOperation() != null){
	    this.operation = result.getOperation();
	    System.out.println("operation : " + this.operation.getOperationName());
	}
	this.setAttribute("operation", this.operation.getOperationName());
	this.setAttribute("relation", rst_elem.getRelationName());
    }

    public AggregatedElement(Document doc, AggregatedElement spElem){
	super((CoreDocumentImpl)doc, spElem.getTagName());
	this.operation = spElem.getOperation();
	this.result = spElem.getAggregationResult();
	this.rst_elem = spElem.getRSTElement();
	this.setAttribute("operation", operation.getOperationName());
	this.setAttribute("relation", rst_elem.getRelationName());
    }

    public String getNS(){
	return ns;
    }

    public Operation getOperation(){
	return operation;
    }

    public RSTElement getRSTElement(){
	return rst_elem;
    }

    /** bugbug **/
    public Document getDSS(){
	Document dss = result.getAggregatedDSS();
	if(dss != null){
	    DocumentImpl newdss = new DocumentImpl();
	    Element newroot = (Element)newdss.importNode(dss.getDocumentElement().cloneNode(true),true);
	    newdss.appendChild(newroot);
	    return newdss;
	}
	return null;
    }

    public void setNS(String ns){
	this.ns = ns;
    }

    public AggregationResult getAggregationResult(){
	return result;
    }

    public String toString(){
	return "aggregated " + operation.getOperationName();
    }

    public short getNodeType2(){
	return BaseElement.AGGREGATED_NODE;
    }

}

