/**
   PropositionElement extends ElementImpl

   created by Ryuichiro Higashinaka 
   2005/05/26

**/

package jsparky;

import org.apache.xerces.dom.*;
import java.util.*;
import org.w3c.dom.*;

public class PropositionElement extends BaseElement implements Aggregatable {

    Proposition prop;
    String ns;

    public PropositionElement(Document doc, Proposition prop, String ns){
	super((CoreDocumentImpl)doc,BaseElement.PROPOSITIONELEMENT_TAGNAME);
	this.prop = prop;
	this.ns = ns;
	this.setAttribute("id",prop.getId());
	this.setAttribute("ns",this.ns);
    }

    public PropositionElement(Document doc, PropositionElement propElem){
	super((CoreDocumentImpl)doc, propElem.getTagName());
	this.prop = propElem.getProposition();
	this.ns = propElem.getNS();
	this.setAttribute("id",prop.getId());
	this.setAttribute("ns",this.ns);
    }

    public Document getDSS(){
	Document dss = prop.getDSS();
	DocumentImpl newdss = new DocumentImpl();
	Element newroot = (Element)newdss.importNode(dss.getDocumentElement().cloneNode(true),true);
	newdss.appendChild(newroot);
	//return prop.getDSS();
	return newdss;
    }

    public void setDSS(Document dss){
	prop.setDSS(dss);
    }

    public Proposition getProposition(){
	return prop;
    }

    public String getNS(){
	return ns;
    }
    
    public void setNS(String ns){
	this.ns = ns;
    }

    public short getNodeType2(){
	return BaseElement.PROPOSITION_NODE;
    }

    public String toString(){
	return "Proposition id=" + prop.getId();
    }

}

