/** process referring expression **/

package jsparky;

import java.util.*;
import org.w3c.dom.*;
import org.apache.xerces.dom.*;
import com.cogentex.real.api.*;

public class ReferringExpression extends Object{

    /** process referring expression within a single dss **/
    public static void process(AggregatedElement elem){
	List lis = getRestaurantList(elem);
	for(int i=0;i<lis.size();i++){
	    System.out.println("[refexp] " + i + " restaurant " + Utils.serialize((Element)lis.get(i)));
	}
	lis = processStartingPoint(lis);
	//process two at a time
	for(int i=0;i<lis.size()-1;i++){
	    Element e1 = (Element)lis.get(i);
	    Element e2 = (Element)lis.get(i+1);
	    System.out.println("[refexp] e1 " + Utils.serialize(e1));
	    System.out.println("[refexp] e2 " + Utils.serialize(e2));

	    List and1 = findAND(e1);
	    List and2 = findAND(e2);
	    if(and1.size() > 0 || and2.size() > 0){
		System.out.println("[refexp] and1 " + and1.size());
		System.out.println("[refexp] and2 " + and2.size());
		continue;
	    }
	    if(isRelativeClause(e2)){
		System.out.println("[refexp] e2 is within a relative clause");
		continue;
	    }

	    String lex1 = e1.getAttribute("lexeme").replaceAll("'s","");
	    String lex2 = e2.getAttribute("lexeme").replaceAll("'s","");
	    if(! e1.getAttribute("org").equals("")){
		lex1 = e1.getAttribute("org");
	    }

	    lex1 = lex1.replaceAll("\\s","_");
	    lex2 = lex2.replaceAll("\\s","_");

	    System.out.println("[refexp] lex1 " + lex1);
	    System.out.println("[refexp] lex2 " + lex2);

	    /** change here **/
	    if(lex1.equals(lex2)){
		String rel = e2.getAttribute("rel");
		if(hasRelativeClause(e2)){
		    e2.setAttribute("org",lex2);
		    e2.setAttribute("lexeme","this_restaurant");
		}else{
		    if(rel.equals("I")){
			e2.setAttribute("pro","pro");
		    }else if(rel.equals("ATTR")){
			e2.setAttribute("pro","poss");
		    }
		}
	    }
	}
    }

    /** is under starting point element **/
    public static boolean isStartingPoint(Element elem){
	Node parent = elem.getParentNode();
	while(parent != null){
	    if(parent.getNodeType() == Node.ELEMENT_NODE){
		Element el = (Element)parent;
		if(el.getAttribute("starting_point").equals("+")){
		    return true;
		}
	    }
	    parent = parent.getParentNode();
	}
	return false;
    }

    /** change order **/
    public static List processStartingPoint(List lis){
	ArrayList sp = new ArrayList();
	for(int i=0;i<lis.size();i++){
	    Element elem = (Element)lis.get(i);
	    if(isStartingPoint(elem)){
		sp.add(elem);
	    }
	}
	ArrayList tmplis = new ArrayList(lis);
	for(int i=0;i<sp.size();i++){
	    tmplis.remove(sp.get(i));
	}
	ArrayList newlis = new ArrayList();
	newlis.addAll(sp);
	newlis.addAll(tmplis);
	return newlis;
    }

    /** check relative clause to prevent : It, which has... **/
    public static boolean hasRelativeClause(Element elem){
	Element el = Utils.getSingleElementByTagAndAttr(elem, RealProMgr.TAG_DSYNTNODE,"rel","DESC-ATTR");
	if(el != null){
	    return true;
	}
	return false;
    }

    /** check relative clause to prevent : It, which has... **/
    public static boolean isRelativeClause(Element elem){
	Element parent = (Element)elem.getParentNode();
	return parent.getAttribute("rel").equals("DESC-ATTR");
    }

    /** find restaurant names **/
    public static List getRestaurantList(AggregatedElement elem){
	ArrayList lis = new ArrayList();
	List dlis = Utils.getAllDSS(elem);
	for(int i=0;i<dlis.size();i++){
	    Document dss = (Document)dlis.get(i);
	    List elis = getRestaurantList(dss);
	    lis.addAll(elis);
	}
	return lis;
    }

    public static List getRestaurantList(Document dss){
	ArrayList lis = new ArrayList();
	NodeList nl = dss.getElementsByTagName(RealProMgr.TAG_DSYNTNODE);
	for(int i=0;i<nl.getLength();i++){
	    Element el = (Element)nl.item(i);
	    if(el.getAttribute("restaurant_name").equals("true")){
		lis.add(el);
	    }
	}
	return lis;
    }

    /** check if there are other coordinated elements **/
    public static List findAND(Element elem){
	ArrayList lis = new ArrayList();
	//NodeList nl = elem.getElementsByTagName(RealProMgr.TAG_DSYNTNODE);
	List nodelis = Utils.getChildrenByTagName(elem,RealProMgr.TAG_DSYNTNODE);
	//for(int i=0;i<nl.getLength();i++){
	for(int i=0;i<nodelis.size();i++){
	    //Element el = (Element)nl.item(i);
	    Element el = (Element)nodelis.get(i);
	    if(el.getAttribute("lexeme").startsWith("AND") && el.getAttribute("rel").equals("COORD")){
		lis.add(el);
	    }
	}
	return lis;
    }

}
