/** 
    CueWord Because NS Operation
    first created by Ryuichiro higashinaka 
    2005/06/01
**/

package jsparky.operations;

import jsparky.*;
import java.util.*;
import org.w3c.dom.*;
import org.apache.xerces.dom.*;
import com.cogentex.real.api.*;

public class CWBecauseNS extends Operation {

    public boolean isInvalidOperationInStructure(String op_name){
	if(op_name.startsWith("PERIOD")){
	    return true;
	}
	return false;
    }

    public AggregationResult aggregate(RSTElement rst_elem, Aggregatable a1, Aggregatable a2) throws AggregationException {

	/** check structure **/
	checkInvalidOperationInStructure(a1,a2);

	String relation = rst_elem.getRelationName();
	if(! relation.equals(Relation.JUSTIFY)){
	    throw new AggregationException("not justify",this);
	}
	if(! (a1.getNS().equals(Relation.NUCLEUS) && a2.getNS().equals(Relation.SATELLITE))){
	    throw new AggregationException("ns order is wrong",this);
	}
	Document dss1 = a1.getDSS();
	Document dss2 = a2.getDSS();
	Element root1 = dss1.getDocumentElement();
	Element root2 = dss2.getDocumentElement();
	Element pred1 = (Element)root1.getFirstChild();
	Element pred2 = (Element)root2.getFirstChild();

	// no a verb (2005/06/13)
	if(! pred1.getAttribute("class").equals("verb") || ! pred2.getAttribute("class").equals("verb")){
	    throw new AggregationException("not a verb",this);
	}

	// because element
	Element because = dss1.createElement(RealProMgr.TAG_DSYNTNODE);
	because.setAttribute("lexeme","because");
	because.setAttribute("rel","ATTR");
	because.setAttribute("class","adverb");
	because.setAttribute("rheme","+");
	pred2.setAttribute("rel","II");
	because.appendChild(dss1.importNode(pred2,true));
	pred1.appendChild(because);
	Document newdss = new DocumentImpl();
	newdss.appendChild(newdss.importNode(root1,true));
	//return newdss;
	return new AggregationResult(newdss,dss1,dss2);
    }

    /** each operation has to return its name **/
    public String getOperationName(){
	return Operation.CW_BECAUSE_NS;
    }

}
