/** 
    CueWord Since SN Operation
    first created by Ryuichiro higashinaka 
    2005/06/01
**/

package jsparky.operations;

import jsparky.*;
import java.util.*;
import org.w3c.dom.*;
import org.apache.xerces.dom.*;
import com.cogentex.real.api.*;

public class CWSinceSN extends Operation {

    public boolean isInvalidOperationInStructure(String op_name){
	if(op_name.startsWith("PERIOD")){
	    return true;
	}
	return false;
    }

    public AggregationResult aggregate(RSTElement rst_elem, Aggregatable a1, Aggregatable a2) throws AggregationException {

	/** check structure **/
	checkInvalidOperationInStructure(a1,a2);

	String relation = rst_elem.getRelationName();
	if(! relation.equals(Relation.JUSTIFY) || ! ( a1.getNS().equals(Relation.SATELLITE) && a2.getNS().equals(Relation.NUCLEUS))){
	    throw new AggregationException("not justify and ns order",this);
	}
	Document dss1 = a1.getDSS();
	Document dss2 = a2.getDSS();
	Element root1 = dss1.getDocumentElement();
	Element root2 = dss2.getDocumentElement();
	Element pred1 = (Element)root1.getFirstChild();
	Element pred2 = (Element)root2.getFirstChild();

	// no a verb (2005/06/13)
	if(! pred1.getAttribute("class").equals("verb") || ! pred2.getAttribute("class").equals("verb")){
	    throw new AggregationException("not a verb",this);
	}

	List and1 = CWBecauseSN.findAND(pred1);
	if(and1.size() > 0){
	    throw new AggregationException("and exists",this);
	}	    

	Element since = dss1.createElement(RealProMgr.TAG_DSYNTNODE);
	since.setAttribute("lexeme","since");
	since.setAttribute("rel","ATTR");
	since.setAttribute("class","adverb");
	since.setAttribute("starting_point","+");
	pred1.setAttribute("rel","II");
	since.appendChild(pred1);
	Element scope = dss1.createElement("rightmost_comma");
	scope.appendChild(since);
	//pred2.appendChild(dss2.importNode(since,true));
	pred2.appendChild(dss2.importNode(scope,true));

	Document newdss = new DocumentImpl();
	newdss.appendChild(newdss.importNode(root2,true));
	return new AggregationResult(newdss,dss1,dss2);
    }

    /** each operation has to return its name **/
    public String getOperationName(){
	return Operation.CW_SINCE_SN;
    }

}
