/** 
    With Reduction Operation SN
    first created by Ryuichiro higashinaka 
    2005/05/31
**/

package jsparky.operations;

import jsparky.*;
import java.util.*;
import org.w3c.dom.*;
import org.apache.xerces.dom.*;
import com.cogentex.real.api.*;

public class WithSN extends Operation {

    /** embedding check **/
    public boolean isInvalidOperationInStructure(String op_name){
	if(op_name.startsWith("PERIOD") || op_name.startsWith("CW") || op_name.startsWith("WITH")){
	    return true;
	}
	return false;
    }

    public AggregationResult aggregate(RSTElement rst_elem, Aggregatable a1, Aggregatable a2) throws AggregationException {

	/** check structure **/
	checkInvalidOperationInStructure(a1,a2);

	String relation = rst_elem.getRelationName();
	if(! relation.equals(Relation.JUSTIFY)){
	    throw new AggregationException("Not justify",this);
	}
	Document dss1 = a1.getDSS();
	Document dss2 = a2.getDSS();
	Element root1 = dss1.getDocumentElement();
	Element root2 = dss2.getDocumentElement();
	Element pred1 = (Element)root1.getFirstChild();
	Element pred2 = (Element)root2.getFirstChild();
	Element pred1relI = Utils.getFirstElementByTagAndAttr(pred1,RealProMgr.TAG_DSYNTNODE,"rel","I");
	Element pred2relI = Utils.getFirstElementByTagAndAttr(pred2,RealProMgr.TAG_DSYNTNODE,"rel","I");

	if(! (a1.getNS().equals(Relation.SATELLITE) && a2.getNS().equals(Relation.NUCLEUS))){
	    throw new AggregationException("invalid ns order",this);
	}
	if(pred1.getAttribute("lexeme").equals("HAVE1")){
	    if(! pred1relI.getAttribute("lexeme").equals(pred2relI.getAttribute("lexeme"))){
		throw new AggregationException("different relI constituent in a1 and a2",this);	    
	    }else{
		Element pred1relII = Utils.getFirstElementByTagAndAttr(pred1,RealProMgr.TAG_DSYNTNODE,"rel","II");
		Element elem = dss2.createElement(RealProMgr.TAG_DSYNTNODE);
		elem.setAttribute("class","preposition");
		elem.setAttribute("lexeme","with");
		elem.setAttribute("rel","ATTR");
		elem.setAttribute("starting_point","+");
		elem.appendChild(dss2.importNode(pred1relII,true));
		Element scope = dss2.createElement("rightmost_comma");
		scope.appendChild(elem);
		//pred2.appendChild(elem);
		pred2.appendChild(scope);
		
		Document newdss = new DocumentImpl();
		newdss.appendChild(newdss.importNode(root2,true));
		return new AggregationResult(newdss,dss1,dss2);
	    }
	}else{
	    throw new AggregationException("condition not match",this);
	}
    }

    /** each operation has to return its name **/
    public String getOperationName(){
	return Operation.WITH_SN;
    }

}
