/** term swap **/
// currently supports only adjectives

package jsparky.review;

import jsparky.*;
import java.util.*;
import org.w3c.dom.*;
import com.cogentex.real.api.*;
import java.io.*;

public class TermSwap extends Object {

    /** word-score adjective-list pair **/
    Hashtable dic;

    /** load dictionary dir **/
    public TermSwap(String dir){
	dic = new Hashtable();
	Vector vec = Utils.getFiles(dir,"txt");
	for(int i=0;i<vec.size();i++){
	    File f = (File)vec.elementAt(i);
	    String path = f.getPath();
	    String name = f.getName();
	    if(name.endsWith(".txt")){
		name = name.substring(0,name.length()-4);
	    }
	    try{
		Hashtable hash = loadFile(path);
		String word = name.substring(0,name.length()-1);
		int score = Integer.parseInt(name.substring(name.length()-1));
		registerHash(word,score,hash);
	    }catch(Exception e){
		e.printStackTrace();
	    }
	}
    }

    /** get adjective based on the true distribution of adjective space **/
    public String getRandomAdjective(String word, int score){
	String key = word + "-" + score;	
	List lis = (List)dic.get(key);
	try{
	    String adjective = (String)Utils.selectOne(lis);
	    return adjective;
	}catch(IllegalArgumentException e){
	    return "";
	}
    }

    /** register word-score adjective-list pair to hash **/
    public void registerHash(String word, int score, Hashtable hash){
	String key = word + "-" + score;
	Enumeration enum = hash.keys();
	ArrayList lis = new ArrayList();
	while(enum.hasMoreElements()){
	    String adjective = (String)enum.nextElement();
	    int count = Integer.parseInt((String)hash.get(adjective));
	    // use only those with one or more occurance
	    if(count < 2){
		continue;
	    }
	    //System.out.println("registering: " + adjective + " " + count);
	    lis.add(adjective);
	    /**
	    for(int i=0;i<count;i++){
		lis.add(adjective);
	    }
	    **/
	}
	dic.put(key,lis);
    }

    /** load food5.txt and so on made by getadjectives.pl **/
    public Hashtable loadFile(String path) throws Exception{
	Hashtable hash = new Hashtable();
	BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(path)));
	String line = "";
	while((line = br.readLine())!=null){
	    String tmp[] = line.split(" : ");
	    hash.put(tmp[0],tmp[1]);
	}
	br.close();
	return hash;
    }

    // utility for RSTPlan
    public void swapAdjective(RSTPlan rst_plan){
	NodeList nl = rst_plan.getElementsByTagName(BaseElement.PROPOSITIONELEMENT_TAGNAME);
	for(int i=0;i<nl.getLength();i++){
	    PropositionElement prop_elem = (PropositionElement)nl.item(i);
	    swapAdjective(prop_elem.getProposition());
	}
    }

    // should use Utils.trueOrFalse()
    public void swapAdjective(Proposition prop){
	Document dss = prop.getDSS();
	Content c = new Content(prop);
	Hashtable scores = c.getScores();
	Enumeration enum = scores.keys();
	while(enum.hasMoreElements()){
	    String key = (String)enum.nextElement();
	    int score = c.getScore(key);
	    /**
	    if(key.equals(Content.FOOD)){
		swapAdjective(dss,"quality","food",score);
	    }
	    **/
	    if(key.equals(Content.SERVICE)){
		swapAdjective(dss,"service","service",score);
	    }
	    else if(key.equals(Content.ATMOSPHERE)){
		swapAdjective(dss,"decor","atmosphere",score);
	    }
	    else if(key.equals(Content.VALUE)){
		swapAdjective(dss,"value","value",score);
	    }
	}
    }

    /** replace search_word's adjective with that of word with score **/
    public void swapAdjective(Document dss, String search_word, String word, int score){
	Element elem = Utils.getSingleElementByTagAndAttr(dss,RealProMgr.TAG_DSYNTNODE,"lexeme",search_word);
	if(elem != null){
	    Element el = Utils.getSingleElementByTagAndAttr(elem,RealProMgr.TAG_DSYNTNODE,"class","adjective");
	    if(el != null){
		String org_adjective = el.getAttribute("lexeme");
		String adjective = getRandomAdjective(word,score);
		if(! adjective.equals("") && ! org_adjective.equalsIgnoreCase(adjective)){
		    el.setAttribute("swapped","true");
		    el.setAttribute("lexeme",adjective);
		}
	    }
	}
    }
}

